#include "ClientConstants.h"

#include "Constant.h"
#include "Property.h"

namespace nonut::g2o
{
	void ClientConstants::init()
	{
		SQObject constTable = getConstTable();

#define GET_CONST(constName) Property<Int> constName ## Prop(#constName, constTable); \
	(constName) = constName ## Prop.get()

		GET_CONST(ATTACK_FRONT);
		GET_CONST(ATTACK_SWORD_LEFT);
		GET_CONST(ATTACK_SWORD_RIGHT);
		GET_CONST(ATTACK_SWORD_FRONT);

		GET_CONST(CONSOLE_COMMAND_NOT_FOUND);
		GET_CONST(CONSOLE_COMMAND_FOUND);

		GET_CONST(DAEDALUS_TYPE_VOID);
		GET_CONST(DAEDALUS_TYPE_FLOAT);
		GET_CONST(DAEDALUS_TYPE_INT);
		GET_CONST(DAEDALUS_TYPE_STRING);
		GET_CONST(DAEDALUS_TYPE_CLASS);
		GET_CONST(DAEDALUS_TYPE_FUNC);
		GET_CONST(DAEDALUS_TYPE_PROTOTYPE);
		GET_CONST(DAEDALUS_TYPE_INSTANCE);
		GET_CONST(DAEDALUS_FLAG_CONST);
		GET_CONST(DAEDALUS_FLAG_RETURN);
		GET_CONST(DAEDALUS_FLAG_EXTERNAL);
		GET_CONST(DAEDALUS_FLAG_MERGED);

		GET_CONST(heroId);

		GET_CONST(HUD_ALL);
		GET_CONST(HUD_HEALTH_BAR);
		GET_CONST(HUD_MANA_BAR);
		GET_CONST(HUD_SWIM_BAR);
		GET_CONST(HUD_FOCUS_BAR);
		GET_CONST(HUD_FOCUS_NAME);
		GET_CONST(HUD_MODE_HIDDEN);
		GET_CONST(HUD_MODE_DEFAULT);
		GET_CONST(HUD_MODE_ALWAYS_VISIBLE);

		GET_CONST(DEFAULT_INTERPOLATION);
		GET_CONST(V2_INTERPOLATION);
		GET_CONST(V1_INTERPOLATION);
		GET_CONST(OLD_INTERPOLATION);
		GET_CONST(NO_INTERPOLATION);

		GET_CONST(KEY_LAYOUT_EN);
		GET_CONST(KEY_LAYOUT_PL);
		GET_CONST(KEY_LAYOUT_RU);
		GET_CONST(KEY_LAYOUT_DE);

		GET_CONST(KEY_ESCAPE);
		GET_CONST(KEY_1);
		GET_CONST(KEY_2);
		GET_CONST(KEY_3);
		GET_CONST(KEY_4);
		GET_CONST(KEY_5);
		GET_CONST(KEY_6);
		GET_CONST(KEY_7);
		GET_CONST(KEY_8);
		GET_CONST(KEY_9);
		GET_CONST(KEY_0);
		GET_CONST(KEY_MINUS);
		GET_CONST(KEY_EQUALS);
		GET_CONST(KEY_BACK);
		GET_CONST(KEY_TAB);
		GET_CONST(KEY_Q);
		GET_CONST(KEY_W);
		GET_CONST(KEY_E);
		GET_CONST(KEY_R);
		GET_CONST(KEY_T);
		GET_CONST(KEY_Y);
		GET_CONST(KEY_U);
		GET_CONST(KEY_I);
		GET_CONST(KEY_O);
		GET_CONST(KEY_P);
		GET_CONST(KEY_LBRACKET);
		GET_CONST(KEY_RBRACKET);
		GET_CONST(KEY_RETURN);
		GET_CONST(KEY_LCONTROL);
		GET_CONST(KEY_A);
		GET_CONST(KEY_S);
		GET_CONST(KEY_D);
		GET_CONST(KEY_F);
		GET_CONST(KEY_G);
		GET_CONST(KEY_H);
		GET_CONST(KEY_J);
		GET_CONST(KEY_K);
		GET_CONST(KEY_L);
		GET_CONST(KEY_SEMICOLON);
		GET_CONST(KEY_APOSTROPHE);
		GET_CONST(KEY_TILDE);
		GET_CONST(KEY_LSHIFT);
		GET_CONST(KEY_BACKSLASH);
		GET_CONST(KEY_Z);
		GET_CONST(KEY_X);
		GET_CONST(KEY_C);
		GET_CONST(KEY_V);
		GET_CONST(KEY_B);
		GET_CONST(KEY_N);
		GET_CONST(KEY_M);
		GET_CONST(KEY_COMMA);
		GET_CONST(KEY_PERIOD);
		GET_CONST(KEY_SLASH);
		GET_CONST(KEY_RSHIFT);
		GET_CONST(KEY_MULTIPLY);
		GET_CONST(KEY_LMENU);
		GET_CONST(KEY_SPACE);
		GET_CONST(KEY_CAPITAL);
		GET_CONST(KEY_F1);
		GET_CONST(KEY_F2);
		GET_CONST(KEY_F3);
		GET_CONST(KEY_F4);
		GET_CONST(KEY_F5);
		GET_CONST(KEY_F6);
		GET_CONST(KEY_F7);
		GET_CONST(KEY_F8);
		GET_CONST(KEY_F9);
		GET_CONST(KEY_F10);
		GET_CONST(KEY_NUMLOCK);
		GET_CONST(KEY_SCROLL);
		GET_CONST(KEY_NUMPAD7);
		GET_CONST(KEY_NUMPAD8);
		GET_CONST(KEY_NUMPAD9);
		GET_CONST(KEY_SUBTRACT);
		GET_CONST(KEY_NUMPAD4);
		GET_CONST(KEY_NUMPAD5);
		GET_CONST(KEY_NUMPAD6);
		GET_CONST(KEY_ADD);
		GET_CONST(KEY_NUMPAD1);
		GET_CONST(KEY_NUMPAD2);
		GET_CONST(KEY_NUMPAD3);
		GET_CONST(KEY_NUMPAD0);
		GET_CONST(KEY_DECIMAL);
		GET_CONST(KEY_F11);
		GET_CONST(KEY_F12);
		GET_CONST(KEY_NUMPADENTER);
		GET_CONST(KEY_RCONTROL);
		GET_CONST(KEY_DIVIDE);
		GET_CONST(KEY_RMENU);
		GET_CONST(KEY_PAUSE);
		GET_CONST(KEY_HOME);
		GET_CONST(KEY_UP);
		GET_CONST(KEY_PRIOR);
		GET_CONST(KEY_LEFT);
		GET_CONST(KEY_RIGHT);
		GET_CONST(KEY_END);
		GET_CONST(KEY_DOWN);
		GET_CONST(KEY_NEXT);
		GET_CONST(KEY_INSERT);
		GET_CONST(KEY_DELETE);
		GET_CONST(KEY_LWIN);
		GET_CONST(KEY_RWIN);
		GET_CONST(KEY_POWER);
		GET_CONST(KEY_SLEEP);
		GET_CONST(KEY_WAKE);

		GET_CONST(GAME_LEFT);
		GET_CONST(GAME_RIGHT);
		GET_CONST(GAME_UP);
		GET_CONST(GAME_DOWN);
		GET_CONST(GAME_ACTION);
		GET_CONST(GAME_ACTION2);
		GET_CONST(GAME_SLOW);
		GET_CONST(GAME_WEAPON);
		GET_CONST(GAME_SMOVE);
		GET_CONST(GAME_SMOVE2);
		GET_CONST(GAME_SHIFT);
		GET_CONST(GAME_END);
		GET_CONST(GAME_INVENTORY);
		GET_CONST(GAME_LOOK);
		GET_CONST(GAME_SNEAK);
		GET_CONST(GAME_STRAFELEFT);
		GET_CONST(GAME_STRAFERIGHT);
		GET_CONST(GAME_SCREEN_STATUS);
		GET_CONST(GAME_SCREEN_LOG);
		GET_CONST(GAME_SCREEN_MAP);
		//TODO: MISSING FIRST PERSON KEY
		GET_CONST(GAME_LOCK_TARGET);
		GET_CONST(GAME_PARADE);
		GET_CONST(GAME_ACTIONLEFT);
		GET_CONST(GAME_ACTIONRIGHT);
		GET_CONST(GAME_LAME_POTION);
		GET_CONST(GAME_LAME_HEAL);

		GET_CONST(MOUSE_LMB);
		GET_CONST(MOUSE_RMB);
		GET_CONST(MOUSE_MMB);

		GET_CONST(OBJ_BASENPC);
		GET_CONST(OBJ_PED);
		GET_CONST(OBJ_PLAYER);
		GET_CONST(OBJ_LOCALPLAYER);
		GET_CONST(OBJ_NPC);
		GET_CONST(OBJ_LOCALNPC);
		GET_CONST(OBJ_ITEM);

		GET_CONST(PLANET_SUN);
		GET_CONST(PLANET_MOON);

		GET_CONST(TRACERAY_VOB_IGNORE);
		GET_CONST(TRACERAY_VOB_IGNORE_NO_CD_DYN);
		GET_CONST(TRACERAY_VOB_IGNORE_CHARACTER);
		GET_CONST(TRACERAY_VOB_IGNORE_PROJECTILES);
		GET_CONST(TRACERAY_VOB_BBOX);
		GET_CONST(zTRACERAY_STAT_IGNORE);
		GET_CONST(TRACERAY_STAT_POLY);
		GET_CONST(TRACERAY_STAT_PORTALS);
		GET_CONST(TRACERAY_POLY_NORMAL);
		GET_CONST(TRACERAY_POLY_IGNORE_TRANSP);
		GET_CONST(TRACERAY_POLY_TEST_WATER);
		GET_CONST(TRACERAY_POLY_2SIDED);

		GET_CONST(VOB_MOB);
		GET_CONST(VOB_MOB_BED);
		GET_CONST(VOB_MOB_CONTAINER);
		GET_CONST(VOB_MOB_DOOR);
		GET_CONST(VOB_MOB_FIRE);
		GET_CONST(VOB_MOB_INTER);
		GET_CONST(VOB_MOB_ITEMSLOT);
		GET_CONST(VOB_MOB_LADDER);
		GET_CONST(VOB_MOB_LOCKABLE);
		GET_CONST(VOB_MOB_SWITCH);
		GET_CONST(VOB_MOB_WHEEL);
		GET_CONST(VOB_NPC);
		GET_CONST(VOB_TRIGGER);
		GET_CONST(VOB_TRIGGER_LIST);
		GET_CONST(VOB_TRIGGER_TELEPORT);
		GET_CONST(VOB_TRIGGER_UNTOUCH);
		GET_CONST(VOB_TRIGGER_WORLD_START);
		GET_CONST(VOB_GAME);
		GET_CONST(VOB_ENGINE);
		GET_CONST(VOB_LIGHT);
		GET_CONST(VOB_SOUND);
		GET_CONST(VOB_START_POINT);
		GET_CONST(VOB_WAY_POINT);
		GET_CONST(VOB_ERROR);

		GET_CONST(WEATHER_SNOW);
		GET_CONST(WEATHER_RAIN);
	}
}
